unit FreeDraw;
{-----------------------------------------------------------------------
  This is a class write by Delphi.
  
  Ļϵĵ㻭߲ࡣĻģд
  һߵN
  N
  ݱΪDisk File / Disk File 
  ݻĻϡ

  δʹá
  classʲôȤĶ鷳һʲôĶ

  Write by: pcplayer99@hotmail.com

  δ޸ģ鷳㽫޸ĺĴһݡлл
---------------------------------------------------------------------------}
interface

uses Classes, Contnrs, Graphics, Types, SysUtils;

type
  TLjnLineRec= Packed record
    PointCount:LongWord;
    Color:TColor;
    Width:LongWord;
  end;

  TFreePoint=class
  public
    X:Integer;
    Y:Integer;
  end;
  
  TPolyline=class
  private
    FList:TObjectList;
    FColor:TColor;
    FWidth:Integer;
    function GetCloro: TColor;
    function GetWidth: Integer;
    procedure SetColor(const Value: TColor);
    procedure SetWidth(const Value: Integer);
  public
    constructor Create;
    destructor Destroy;override;
    procedure Draw(ACanvas: TCanvas);
    procedure AddPoint(X,Y:Integer);
  published
    property LjnColor:TColor read GetCloro write SetColor;
    property LjnWidth:Integer read GetWidth write SetWidth;
  end;

  TPolylineList=class
  private
    FList:TObjectList;
  public
    constructor Create;
    destructor Destroy;override;
    function NewLine:TPolyline;
    procedure DeleteLine(Index:Integer);
    procedure Draw(ACanvas: TCanvas);
    function IsPointOnLine(XA,YA,XB,YB,XC,YC, Tolerance: Double): Boolean;
    function CheckPointOnLine(X,Y:Integer):Integer;
    procedure SaveToFile(AFileName:string);
    procedure LoadFromFile(AFileName:string);
    procedure ClearLine;
  published
  end;

implementation

{ TPolyline }

procedure TPolyline.AddPoint(X, Y: Integer);
var
  APoint:TFreePoint;
begin
  APoint:=TFreePoint.Create;
  APoint.X:=X;
  APoint.Y:=Y;
  FList.Add(APoint);
end;

constructor TPolyline.Create;
begin
  inherited;
  FList:=TObjectList.Create;
  FList.OwnsObjects:=True;
end;

destructor TPolyline.Destroy;
begin
  FList.Clear;
  FList.Free;
  inherited;
end;

procedure TPolyline.Draw(ACanvas: TCanvas);
var
  i:Integer;
  APoint:TFreePoint;
begin
  if FList.Count=0 then Exit;
  APoint:=TFreePoint(FList.Items[0]);
  ACanvas.MoveTo(APoint.X,APoint.Y);
  ACanvas.Pen.Color:=FColor;
  ACanvas.Pen.Width:=FWidth;

  for i:=1 to FList.Count-1 do
  begin
    APoint:=TFreePoint(FList.Items[i]);
    ACanvas.LineTo(APoint.X,APoint.Y);
  end;
end;

function TPolyline.GetCloro: TColor;
begin
  Result:=FColor;
end;

function TPolyline.GetWidth: Integer;
begin
  Result:=FWidth;
end;

procedure TPolyline.SetColor(const Value: TColor);
begin
  FColor:=Value;
end;

procedure TPolyline.SetWidth(const Value: Integer);
begin
  FWidth:=Value;
end;

{ TPolylineList }

function TPolylineList.CheckPointOnLine(X, Y: Integer): Integer;
var
  i,j:Integer;
  ALine:TPolyline;
  PointA,PointB:TFreePoint;
begin
{---------------------------------------------------------------------
  ǷһϡһߣFListһ
  ֵǸFListIndexֵ㲻κһϣ򷵻-1
------------------------------------------------------------------------}
  Result:=-1;
  for i:=0 to FList.Count-1 do
  begin
    ALine:=TPolyline(FList.Items[i]);
    if not Assigned(ALine) then
    begin
      raise Exception.Create('û߶TPolylineʵڣ');
    end;

    for j:=0 to ALine.FList.Count-2 do
    begin
      PointA:=TFreePoint(ALine.FList.Items[j]);
      PointB:=TFreePoint(ALine.FList.Items[j+1]);
      if not Assigned(PointA) then
      begin
        raise Exception.Create('ߵĵһ󲻴');
      end;
      if not Assigned(PointB) then
      begin
        raise Exception.Create('ߵĵڶ󲻴');
      end;

      if IsPointOnLine(PointA.X,
                       PointA.Y,
                       PointB.X,
                       PointB.Y,
                       X,Y,4) then
      begin
        Result:=i;
        Break;
      end;
    end;
    if Result>-1 then Break;
  end;
end;

procedure TPolylineList.ClearLine;
begin
  FList.Clear;
end;

constructor TPolylineList.Create;
begin
  FList:=TObjectList.Create;
  FList.OwnsObjects:=True;
end;

procedure TPolylineList.DeleteLine(Index: Integer);
begin
  FList.Delete(Index);
end;

destructor TPolylineList.Destroy;
begin
  FList.Clear;
  FList.Free;
  inherited;
end;

procedure TPolylineList.Draw(ACanvas: TCanvas);
var
  i:Integer;
  ALine:TPolyline;
begin
  if FList.Count=0 then Exit;
  for i:=0 to FList.Count-1 do
  begin
    ALine:=TPolyline(FList.Items[i]);
    ALine.Draw(ACanvas);
  end;
end;

function TPolylineList.IsPointOnLine(XA, YA, XB, YB, XC, YC,
  Tolerance: Double): Boolean;
var
  L,R,S: Double;

begin

{-----------------------------------------------------------------------

  XC/YC һ㣻XA/YAXB/YBһߡXC/YC Ƿ

----------------------------------------------------------------------------}

  Result:=False;

  L:=SQRT(((XB-XA)*(XB-XA)+(YB-YA)*(YB-YA)));

  if l<>0 then
  begin
    R:= ((YA-YC)*(YA-YB)-(XA-XC)*(XB-XA))/(L*L);
    S:= ((YA-YC)*(XB-XA)-(XA-XC)*(YB-YA))/(L*L);
    if (r>0) and (r<1) then if Abs(S*L)<=Tolerance then Result:=True;  //s*l=distance
  end;
end;

procedure TPolylineList.LoadFromFile(AFileName: string);
var
  AFile:TFileStream;
  APoint:TPoint;
  AFreePoint:TFreePoint;
  ALine:TPolyLine;
  ALineRec:TLjnLineRec;
  i,j:Integer;
begin
  FList.Clear;
  AFile:=TFileStream.Create(AFileName,fmOpenRead);
  try
    AFile.Position:=0;
    while AFile.Position<(AFile.Size-SizeOf(TPoint)) do
    begin
      AFile.Read(ALineRec,SizeOf(ALineRec));
      ALine:=NewLine;
      ALine.FColor:=ALineRec.Color;
      ALine.FWidth:=ALineRec.Width;
      for i:=0 to ALineRec.PointCount-1 do
      begin
        AFile.Read(APoint,SizeOf(APoint));
        ALine.AddPoint(APoint.X,APoint.Y);
      end;
    end;
  finally
    AFile.Free;
  end;
end;

function TPolylineList.NewLine: TPolyline;
var
  ALine:TPolyline;
begin
  ALine:=TPolyline.Create;
  FList.Add(ALine);
  Result:=ALine;
end;

procedure TPolylineList.SaveToFile(AFileName: string);
var
  AFile:TFileStream;
  APoint:TPoint;
  AFreePoint:TFreePoint;
  ALine:TPolyLine;
  ALineRec:TLjnLineRec;
  i,j:Integer;
begin
{--------------------------------------------------------------------
  ߱ΪļļͷһߵRecord¼ߵĵ//ɫ
  Ȼ㱣ں档ʱȶͷݵN
  N󣬺ݣһߵrecord.
------------------------------------------------------------------------}
  AFile:=TFileStream.Create(AFileName,fmCreate);
  try
    if FList.Count=0 then Exit;
    for i:=0 to FList.Count-1 do
    begin
      ALine:=TPolyLine(FList.Items[i]);
      ALineRec.PointCount:=ALine.FList.Count;
      ALineRec.Color:=ALine.FColor;
      ALineRec.Width:=ALine.FWidth;
      AFile.Write(ALineRec,SizeOf(ALineRec));

      for j:=0 to ALine.FList.Count-1 do
      begin
        AFreePoint:=TFreePoint(ALine.FList.Items[j]);
        APoint.X:=AFreePoint.X;
        APoint.Y:=AFreePoint.Y;

        AFile.Write(APoint,SizeOf(APoint));
      end;
    end;
  finally
    AFile.Free;
  end;
end;

end.
